OpenTTD

Data Structures | Typedefs | Functions | Variables
bridge_gui.cpp File Reference

Graphical user interface for bridge construction. More...

`#include "stdafx.h"`
`#include "error.h"`
`#include "command_func.h"`
`#include "rail.h"`
`#include "strings_func.h"`
`#include "window_func.h"`
`#include "sound_func.h"`
`#include "gfx_func.h"`
`#include "tunnelbridge.h"`
`#include "sortlist_type.h"`
`#include "widgets/dropdown_func.h"`
`#include "core/geometry_func.hpp"`
`#include "cmd_helper.h"`
`#include "tunnelbridge_map.h"`
`#include "road_gui.h"`
`#include "widgets/bridge_widget.h"`
`#include "table/strings.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
struct | BuildBridgeData
| Carriage for the data we need if we want to build a bridge. More...
class | BuildBridgeWindow
| Window class for handling the bridge-build GUI. More...

## Typedefs
typedef GUIList< BuildBridgeData > | GUIBridgeList
| List of bridges, used in BuildBridgeWindow.

## Functions
void | CcBuildBridge (const CommandCost &result, TileIndex end_tile, uint32 p1, uint32 p2)
| Callback executed after a build Bridge CMD has been called. More...
void | ShowBuildBridgeWindow (TileIndex start, TileIndex end, TransportType transport_type, byte road_rail_type)
| Prepare the data for the build a bridge window. More...

## Variables
static BridgeType | _last_railbridge_type = 0
| The type of the last built rail bridge.
static BridgeType | _last_roadbridge_type = 0
| The type of the last built road bridge.
static const NWidgetPart | _nested_build_bridge_widgets []
| Widgets of the bridge gui. More...
static WindowDesc | _build_bridge_desc (WDP_AUTO, "build_bridge", 200, 114, WC_BUILD_BRIDGE, WC_BUILD_TOOLBAR, WDF_CONSTRUCTION, _nested_build_bridge_widgets, lengthof(_nested_build_bridge_widgets))
| Window definition for the rail bridge selection window. More...

## Detailed Description

Graphical user interface for bridge construction.

Definition in file bridge_gui.cpp.

## Function Documentation

## ◆ CcBuildBridge()

void CcBuildBridge | ( | const CommandCost & | result,
|  | TileIndex | end_tile,
|  | uint32 | p1,
|  | uint32 | p2
| ) |  |

Callback executed after a build Bridge CMD has been called.

Parameters

  result | Whether the build succeeded
  end_tile | End tile of the bridge.
  p1 | packed start tile coords (~ dx)
  p2 | various bitstuffed elements p2 = (bit 0- 7) - bridge type (hi bh) p2 = (bit 8-11) - rail type or road types. p2 = (bit 15-16) - transport type.

Definition at line 61 of file bridge_gui.cpp.

References _settings_client, SoundSettings::confirm, CommandCost::Failed(), and ClientSettings::sound.

Referenced by BuildBridgeWindow::BridgeSpeedSorter(), and ShowBuildBridgeWindow().

## ◆ ShowBuildBridgeWindow()

void ShowBuildBridgeWindow | ( | TileIndex | start,
|  | TileIndex | end,
|  | TransportType | transport_type,
|  | byte | road_rail_type
| ) |  |

Prepare the data for the build a bridge window.

If we can't build a bridge under the given conditions show an error message.

Parameters

  start | The start tile of the bridge
  end | The end tile of the bridge
  transport_type | The transport type
  road_rail_type | The road/rail type

Definition at line 361 of file bridge_gui.cpp.

References _ctrl_pressed, _last_railbridge_type, _last_roadbridge_type, CalcBridgeLenCostFactor(), CcBuildBridge(), CheckBridgeAvailability(), CMD_BUILD_BRIDGE, CMD_MSG, CommandFlagsToDCFlags(), DC_QUERY_COST, DeleteWindowByClass(), DoCommand(), DoCommandP(), CommandCost::Failed(), GetCommandFlags(), CommandCost::GetErrorMessage(), GetTunnelBridgeLength(), INVALID_STRING_ID, TRANSPORT_RAIL, TRANSPORT_ROAD, and WC_BUILD_BRIDGE.

## Variable Documentation

## ◆ _build_bridge_desc

WindowDesc _build_bridge_desc(WDP_AUTO, "build_bridge", 200, 114, WC_BUILD_BRIDGE, WC_BUILD_TOOLBAR, WDF_CONSTRUCTION, _nested_build_bridge_widgets, lengthof(_nested_build_bridge_widgets))
| static

Window definition for the rail bridge selection window.

## ◆ _nested_build_bridge_widgets

const NWidgetPart _nested_build_bridge_widgets[]
| static

Initial value:
= {
NWidget(NWID_HORIZONTAL),
NWidget(WWT_CLOSEBOX, COLOUR_DARK_GREEN),
NWidget(WWT_CAPTION, COLOUR_DARK_GREEN, WID_BBS_CAPTION), SetDataTip(STR_SELECT_RAIL_BRIDGE_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
NWidget(WWT_DEFSIZEBOX, COLOUR_DARK_GREEN),
EndContainer(),
NWidget(NWID_HORIZONTAL),
NWidget(NWID_VERTICAL),
NWidget(NWID_HORIZONTAL),
NWidget(WWT_TEXTBTN, COLOUR_DARK_GREEN, WID_BBS_DROPDOWN_ORDER), SetFill(1, 0), SetDataTip(STR_BUTTON_SORT_BY, STR_TOOLTIP_SORT_ORDER),
NWidget(WWT_DROPDOWN, COLOUR_DARK_GREEN, WID_BBS_DROPDOWN_CRITERIA), SetFill(1, 0), SetDataTip(0x0, STR_TOOLTIP_SORT_CRITERIA),
EndContainer(),
NWidget(WWT_MATRIX, COLOUR_DARK_GREEN, WID_BBS_BRIDGE_LIST), SetFill(1, 0), SetResize(0, 22), SetMatrixDataTip(1, 0, STR_SELECT_BRIDGE_SELECTION_TOOLTIP), SetScrollbar(WID_BBS_SCROLLBAR),
EndContainer(),
NWidget(NWID_VERTICAL),
NWidget(NWID_VSCROLLBAR, COLOUR_DARK_GREEN, WID_BBS_SCROLLBAR),
NWidget(WWT_RESIZEBOX, COLOUR_DARK_GREEN),
EndContainer(),
EndContainer(),
}
WID_BBS_DROPDOWN_ORDER
Direction of sort dropdown.
Definition: bridge_widget.h:18
SetResize
static NWidgetPart SetResize(int16 dx, int16 dy)
Widget part function for setting the resize step.
Definition: widget_type.h:930
NWID_HORIZONTAL
Horizontal container.
Definition: widget_type.h:75
WWT_RESIZEBOX
Resize box (normally at bottom-right of a window)
Definition: widget_type.h:68
WWT_CLOSEBOX
Close box (at top-left of a window)
Definition: widget_type.h:69
WID_BBS_CAPTION
Caption of the window.
Definition: bridge_widget.h:17
SetMatrixDataTip
static NWidgetPart SetMatrixDataTip(uint8 cols, uint8 rows, StringID tip)
Widget part function for setting the data and tooltip of WWT_MATRIX widgets.
Definition: widget_type.h:1032
WWT_DEFSIZEBOX
Default window size box (at top-right of a window, between WWT_SHADEBOX and WWT_STICKYBOX) ...
Definition: widget_type.h:65
SetDataTip
static NWidgetPart SetDataTip(uint32 data, StringID tip)
Widget part function for setting the data and tooltip.
Definition: widget_type.h:1014
NWidget
static NWidgetPart NWidget(WidgetType tp, Colours col, int16 idx=-1)
Widget part function for starting a new &#39;real&#39; widget.
Definition: widget_type.h:1114
WWT_MATRIX
Grid of rows and columns.
Definition: widget_type.h:59
WID_BBS_BRIDGE_LIST
List of bridges.
Definition: bridge_widget.h:20
WWT_CAPTION
Window caption (window title between closebox and stickybox)
Definition: widget_type.h:61
WID_BBS_SCROLLBAR
Scrollbar of the list.
Definition: bridge_widget.h:21
NWID_VERTICAL
Vertical container.
Definition: widget_type.h:77
EndContainer
static NWidgetPart EndContainer()
Widget part function for denoting the end of a container (horizontal, vertical, WWT_FRAME, WWT_INSET, or WWT_PANEL).
Definition: widget_type.h:999
WWT_DROPDOWN
Drop down list.
Definition: widget_type.h:70
SetFill
static NWidgetPart SetFill(uint fill_x, uint fill_y)
Widget part function for setting filling.
Definition: widget_type.h:983
NWID_VSCROLLBAR
Vertical scrollbar.
Definition: widget_type.h:84
SetScrollbar
static NWidgetPart SetScrollbar(int index)
Attach a scrollbar to a widget.
Definition: widget_type.h:1095
WID_BBS_DROPDOWN_CRITERIA
Criteria of sort dropdown.
Definition: bridge_widget.h:19
WWT_TEXTBTN
(Toggle) Button with text
Definition: widget_type.h:55

Widgets of the bridge gui.

Definition at line 316 of file bridge_gui.cpp.